using System;
using System.Collections.Generic;
using System.Text;

namespace Unit4.CollectionsLib
{
    /// <summary> 
    /// <h3 dir="rtl" style="color:red; font-family: Helvetica, Arial, sans-serif">
    ///       LIFO    . 
    /// </h3>
    /// </summary>
    /// <author>   ,   ,  ,  </author>
    /// <version> 12.11.2007 </version>
    /// <typeparam name="T">    </typeparam>
    public class Stack<T>
    {
        private List<T> data;  //    

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///    
        /// </b>
        /// </summary>
        public Stack()
        {
            this.data = new List<T>();
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///   ''    , '' 
        /// </b>
        /// </summary>
        /// <returns> ``    , ``  </returns>
        public bool IsEmpty()
        {
            return (this.data.IsEmpty());
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///     x    ()
        /// </b>
        /// </summary>
        /// <param name="x">     </param>
        public void Push(T x)
        {
            this.data.Insert(null, x);
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///          ()
        /// <br/><u>:</u>    
        /// </b>
        /// </summary>
        /// <returns>    </returns>
        public T Pop()
        {
            T x = this.data.GetFirst().GetInfo();
            this.data.Remove(this.data.GetFirst());
            return (x);
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///         
        /// <br/><u>:</u>    
        /// </b>
        /// </summary>
        /// <returns>      </returns>
        public T Top()
        {
            return (this.data.GetFirst().GetInfo());
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///     ,   ,  (x1    ):
        /// [x1,x2,...,xn]
        /// </b>
        /// </summary>
        /// <returns>     </returns>
        public override string ToString()
        {
            Node<T> pos = this.data.GetFirst();

            string str = "[";
            while (pos != null)
            {
                str = str + pos.GetInfo().ToString();
                if (pos.GetNext() != null)
                    str = str + ",";
                pos = pos.GetNext();
            }
            str = str + "]";

            return (str);
        }
    }
}
