using System;
using System.Collections.Generic;
using System.Text;

namespace Unit4.UtilsLib
{
    /// <summary>
    ///     '' ( )  ..
    /// </summary>
    /// <author>   ,   ,  ,  </author>
    /// <version> 27.11.2007 </version>
    public class Date
    {
        private int day;
        private int month;
        private int year;

        /// <summary>
        ///        
        /// </summary>
        public Date()
        {
            DateTime dt = DateTime.Now;
            this.day = dt.Day;
            this.month = dt.Month;
            this.year = dt.Year;
        }

        /// <summary>
        ///       .
        ///     
        /// </summary>
        /// <param name="day">  :    1-31 </param>
        /// <param name="month">  :    1-12 </param>
        /// <param name="year">  :     4  </param>
        public Date(int day, int month, int year)
        {
            this.day = day;
            this.month = month;
            this.year = year;
        }

        /// <summary>
        ///   
        /// </summary>
        /// <param name="date">   </param>
        public Date(Date date)
        {
            this.day = date.day;
            this.month = date.month;
            this.year = date.year;
        }

        /// <summary>
        ///      
        /// </summary>
        /// <returns>    4       </returns>
        public int GetYear()
        {
            return this.year;
        }

        /// <summary>
        ///      
        /// </summary>
        /// <returns>         </returns>
        public int GetMonth()
        {
            return this.month;
        }

        /// <summary>
        ///      
        /// </summary>
        /// <returns>         </returns>
        public int GetDay()
        {
            return this.day;
        }

        /// <summary>
        ///       
        /// </summary>
        /// <param name="year">     4  </param>
        public void SetYear(int year)
        {
            this.year = year;
        }

        /// <summary>
        ///       
        /// </summary>
        /// <param name="month">     1-12 </param>
        public void SetMonth(int month)
        {
            this.month = month;
        }

        /// <summary>
        ///       
        /// </summary>
        /// <param name="day">     1-31 </param>
        public void SetDay(int day)
        {
            this.day = day;
        }

        /// <summary>
        ///     
        /// </summary>
        /// <param name="date">    </param>
        /// <returns>
        ///  0    <br/>
        ///           <br/>
        ///          
        /// </returns>
        public int CompareTo(Date date)
        {
            if (this.year != date.year)
                return this.year - date.year;

            //equals in years
            if (this.month != date.month)
                return this.month - date.month;

            //equals also in months
            return this.day - date.day;
        }

        /// <summary>
        ///     
        /// </summary>
        /// <returns>      : .. </returns>
        public override string ToString()
        {
            return this.day + "." + this.month + "." + this.year;
        }
    }
}
