using System;
using System.Collections.Generic;
using System.Text;

namespace Unit4.CollectionsLib
{
    /// <summary>
    /// <h3 dir="rtl" style="color:red; font-family: Helvetica, Arial, sans-serif">
    ///        T   .
    /// </h3> 
    /// <h3 dir="rtl" style="color:red; font-family: Helvetica, Arial, sans-serif">
    ///        T   .
    /// </h3>
    /// </summary>
    /// <author>   ,   ,  ,  </author>
    /// <version> 12.11.2007 </version>
    /// <typeparam name="T">    </typeparam>
    public class Node<T>
    {
        private T info;
        private Node<T> next;
        
        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///   ;    x    
        /// </b>
        /// </summary>
        /// <param name="x">   </param>
        public Node(T x)
        {
            this.info = x;
            this.next = null;
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///   ;    x     next.
        ///   next   null
        /// </b>
        /// </summary>
        /// <param name="x">   </param>
        /// <param name="next">    </param>
        public Node(T x, Node<T> next)
        {
            this.info = x;
            this.next = next;
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///      
        /// </b>
        /// </summary>
        /// <returns>   </returns>
        public T GetInfo()
        {
            return (this.info);
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///       -x
        /// </b>
        /// </summary>
        /// <param name="x">    </param>
        public void SetInfo(T x)
        {
            this.info = x;
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///     ;    ,   null
        /// </b> 
        /// </summary>
        /// <returns>    </returns>
        public Node<T> GetNext()
        {
            return (this.next);
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///      -next.
        ///   next   null
        /// </b>
        /// </summary>
        /// <param name="next">    </param>
        public void SetNext(Node<T> next)
        {
            this.next = next;
        }

        /// <summary>
        /// <dt dir="rtl"/>
        /// <b>
        ///      
        /// </b>
        /// </summary>
        /// <returns>     </returns>
        public override string ToString()
        {
            return ("" + this.info);
        }
    }
}
